/* AP 24-sep-12	datastore.c					*/
/*		ein Beispiel zur Verwendung Listen		*/

# include <stdio.h>
# include <string.h>
# include <stdlib.h>

# include "evlist.h"

# define LEN 80

int main( int argc, char *argv[] ) {
	char buf[LEN];
	int val;
	listElemPT head = NULL;
	listElemPT curr = NULL;
	listElemPT tmp;

	while (1) {
		printf("Command: n <text>, d (elete), "
			"+, -, s (sort), p (rint) q (quit)\n");
		memset( buf, '\0', LEN );
		/* gets( buf ); */
		fgets( buf, LEN, stdin );
		if (buf[LEN-1] == '\0') {
			/* fgets() hat Zeilenumbruch angehaengt */
			buf[ strlen(buf)-1 ] = '\0';
		}
		switch( buf[0] ) {
			case 'n': 
				val = atoi( &buf[2] );
				if (! head) {
					curr = insertElem( head, val );
					head = curr;
				} else
					curr = insertElem( curr, val );
				break;
			case 'p':
				if (! curr) {
					printf("nothing stored\n");
					continue;
				}
				tmp = head;
				while (tmp) {
					printf( "%d\n", tmp->count );
					tmp = tmp->next;
				}
				break;
			case 'd':
				if (! curr) {
					printf("nothing to delete\n");
					continue;
				}
				curr = deleteElem( head, curr );
				if (! curr) 
					head = NULL;
				break;
			case '+':
				if (! curr) {
					printf("empty\n");
					continue;
				}
				tmp = nextElem( curr );
				if (! tmp) {
					printf("already at top\n");
					continue;
				}
				curr = tmp;
				printf( "%d\n", curr->count );
				break;
			case '-':
				if (! curr) {
					printf("empty\n");
					continue;
				}
				tmp = prevElem( head, curr );
				if (! tmp) {
					printf("already at bottom\n");
					continue;
				}
				curr = tmp;
				printf( "%d\n", curr->count );
				break;
			case 's':
				head = sortList( head );
				printf("list now sorted\n");
				break;
			case 'q':
				return 0;
			default:
				break;
		}
	}
}


