/* AP 24-sep-12 evlist.c					*/
/*		einfach verkettete Liste mit Zugriffsfunktionen	*/

# include <stdlib.h>
# include "evlist.h"

/* gibt Zeiger auf neues Element zurueck */
listElemPT insertElem( listElemPT curr, int count ) {
	listElemPT new = malloc( sizeof( listElemT ));

	new->count = count;
	new->next = NULL;

	if (! curr) return new;
	
	new->next = curr->next;
	curr->next = new;
	
	return new;
}

/* gibt Zeiger auf neues Element zurueck */
listElemPT appendElem( listElemPT head, int count ) {
	listElemPT new = malloc( sizeof( listElemT ));

	new->count = count;
	new->next = NULL;

	if (! head) return new;

	while (head->next) 
		head = head->next;
	head->next = new;

	return new;
}

/* sortiert die Liste nach aufsteigenden Werten */
/* gibt Listenanfang zurueck */
listElemPT sortList( listElemPT head ) {
	listElemPT prev, curr, tmp;
	int swapped = 0;

	/* empty list */
	if (! head ) return head;
	/* one element, already sorted */
	if (! head->next) return head;

	/* bubble sort */	
	do {
		swapped = 0;
		if (head->count > head->next->count) {
			/* special case: head element */
			tmp = head;
			head = head->next;
			tmp->next = head->next;
			head->next = tmp;
			swapped = 1;
		}
		prev = head;
		curr = head->next;
		while (curr && curr->next) {
			if (curr->count > curr->next->count) {
			/* swap elements */
				prev->next = curr->next;
				curr->next = curr->next->next;
				prev->next->next = curr;
				swapped = 1;
			}
			prev = curr;
			curr = curr->next;
		}
	} while (swapped);	
	return head;
}

/* gibt Zeiger auf naechstes Listenelement zurueck */
/* NULL am Listenende */
listElemPT nextElem( listElemPT curr ) {
	if (! curr) return NULL;
	return curr->next;
}

/* gibt Zeiger auf vorheriges Listenelement zurueck */
/* NULL am Listenanfang */
listElemPT prevElem( listElemPT head, listElemPT curr ) {
	if (! head || !curr) return NULL;
	while (head && head->next != curr)
		head = head->next;
	return head;
}

/* gibt Zahl der Listenelemente zurueck */
int lenList( listElemPT head ) {
	int len = 1;

	if (! head) return 0;
	while (head->next) {
		head = head->next;
		len++;
	}
	return len;
}

/* loescht Element aus der Liste */
/* gibt Zeiger auf Vorgaenger zurueck */
/* NULL wenn Liste leer	*/
listElemPT deleteElem( listElemPT head, listElemPT elem ) {
	listElemPT prv = prevElem( head, elem );

	if (! prv ) {
		if (! elem) return NULL;
		/* head == elem */
		free( elem );
		return NULL;
	}
	prv->next = elem->next;
	free( elem );
	return prv;
}
