/* AP 20-sep-12 getword.c		*/
/*		read stdin, return word	*/

# include <ctype.h>
# include <stdio.h>
# include <unistd.h>

# define BUFSIZE 80

char * getword () {
	static int numc, pos, opos;
	static char buf[BUFSIZE];
	static int init;

	if (!init) {
		init = 1;
		numc = read( 0, buf, BUFSIZE );
	}
	if (!numc)
		return (char *) 0;
	/* ignore white space */
	while (isspace(buf[pos])) {
		pos++;
		if (pos > numc) {
		/* reached end of buffer */
			numc = read( 0, buf, BUFSIZE );
			pos = 0;
			if (!numc) {
				/* reached end of input */
				return (char *) 0;
			}
		}
	}
	opos = pos;
	/* read word */
	while (!isspace(buf[pos])) {
		pos++;
		if (pos >= numc) {
		/* word extends over end of buffer */
			int i;
			if (pos-opos >= BUFSIZE) {
				/* single word extends over BUFSIZE */
				fprintf(stderr, "getword: "
					"giving up - word too long\n");
				return (char *) 0;
			}
			/* shift buffer content	*/
			for (i = opos; i < pos; i++)	
				buf[i-opos] = buf[i];
			pos = pos-opos;
			opos = 0;
			numc = read(0, &buf[pos], BUFSIZE-pos);
			if (!numc) {
				/* reached end of input */
				buf[pos] = '\0';
				return (char *) &buf[opos];
			} else 
				numc +=pos;
		}
	}
	buf[pos] = '\0';
	return (char *) &buf[opos];
}
