/* AP 20-sep-12	rectangle.c			*/
/*		Strukturen und Funktionen	*/

# include <stdio.h>

struct point {
	int x;
	int y;
};

struct rect {
	struct point pt1;
	struct point pt2;
};

/* function makepoint - initializer */
struct point makepoint( int x, int y ) {
	struct point temp;

	/* x und y sind lokale Variablen (Parameter)   */
	/* kein Konflikt mit Strukturelementen x und y */
	temp.x = x;
	temp.y = y;
	return temp;
}

/* addiere zwei Punkte */
struct point addpoint( struct point p1, struct point p2 ) {
	p1.x += p2.x;
	p1.y += p2.y;
	return p1;
}

/* liegt Punkt im Rechteck? 			    */
/* Rechteck muss normalisiert sein: 		    */
/* pt1 - linke untere Ecke, pt2 - rechte obere Ecke */
int ptinrect(struct point p, struct rect r) {
	return     p.x >= r.pt1.x && p.x < r.pt2.x 
		&& p.y >= r.pt1.y && p.y < r.pt2.y;
}

/* Rechteck normalisieren */
struct rect normalize( struct rect r ) {
	struct rect temp;

# define min( a, b) ((a) < (b) ? (a) : (b))
# define max( a, b) ((a) > (b) ? (a) : (b))
	
	temp.pt1.x = min( r.pt1.x, r.pt2.x );
	temp.pt1.y = min( r.pt1.y, r.pt2.y );
	temp.pt2.x = max( r.pt1.x, r.pt2.x );
	temp.pt2.y = max( r.pt1.y, r.pt2.y );

	return temp;
}

/* statische Variablen */
struct rect screen;
struct point middle;

# define XMAX 640
# define YMAX 480

int main() {
	screen.pt1 = makepoint( 0, 0 );
	screen.pt2 = makepoint( XMAX, YMAX );
	middle = makepoint((screen.pt1.x + screen.pt2.x) / 2,
			   (screen.pt1.y + screen.pt2.y) / 2 );

	screen = normalize( screen );

	printf("Middle is in on screen? %c\n",
		ptinrect( middle, screen ) ? 'Y' : 'N' );
}

