/* AP 26-sep-12 test2stack.c			*/
/*		testdriver for Integer stack 	*/
/*		improved error handling		*/

# include <stdio.h>
# include <ctype.h>
# include <stdlib.h>
# include <string.h>
# include "i2stack.h"

# define LEN 80

void get_input( char * command[], int * val ) {
	static char buf[LEN+1];
	int i;

	*val = 0;
	fgets( buf, LEN, stdin );
	buf[LEN] = '\0';
	for (i = 0; i < LEN; i++ ) 
		if (isspace( buf[i] )) {
			buf[i] = '\0';
			break;
		}
	for ( i++; i < LEN; i++ )
		if (!isspace( buf[i] ))  
			break;
	if (i < LEN)
		*val = atoi( &buf[i] );
	*command = buf;
}

int main(int argc, char * argv[]) {
	char* prog = argv[0];
	int cont = 1;
	char * command;
	int val;
	Stack s = NULL;

	printf("%s: Integer Stack mit Fehlercode in Stack-Struktur\n", prog);

	while( cont ) {
		printf("{init | push | pop | swap |"
			" top | free | quit} <int>\n");
		get_input( &command, &val );

		if (strcmp( command, "init" ) == 0) {
			if (s) 
				printf("already initialized\n");
			else 	
				s = allocStack();
			print_error( s );
		} else if (strcmp( command, "push" ) == 0) {
			push( s, val );
			print_error( s );
		} else if (strcmp( command, "pop" ) == 0) {
			val = pop( s );
			printf("pop: value = %d\n", val );
			print_error( s );
		} else if (strcmp( command, "swap" ) == 0) {
			swap( s );
			print_error( s );
		} else if (strcmp( command, "top" ) == 0) {
			val = top( s );
			printf("top: value = %d\n", val );
			print_error( s );
		} else if (strcmp(command, "free") == 0) {
			freeStack( s );
			s = (Stack) 0;
			print_error( s );				
		} else if (strcmp(command, "quit") == 0) {
			cont = 0;
		} else {
			printf("wie bitte?\n");
			print_error( s );
		}
	}
}
