/* AP 20-sep-12	wordcount.c			*/
/*		Vorkommen von Worten zählen	*/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# ifdef USE_GETWORD
# include "getword.h"
# endif

# define BUFSIZE 80


struct key {
	char * word;
	int count;
};

struct key * init_keytab( int argc, char * words[] ) {
	int i;
	struct key * keytab = malloc( sizeof(struct key) * argc );

	for (i = 0; i < argc; i++) {
		keytab[i].word = malloc( strlen(words[i]) + 1 );
		strcpy( keytab[i].word, words[i] );
		keytab[i].count = 0;
	}
	return keytab;
}

int find_word( int num_keys, struct key * nkey, char * word ) {
	int i;

	for (i = 0; i < num_keys; i++) {
		if (strcmp(word, nkey->word) == 0) {
			nkey->count++;
			return 1;
		}
		nkey++;
	}
	return 0;
}

void print_keys( int num_keys, struct key * nkey ) {
	int i;

	for (i = 0; i < num_keys; i++, nkey++ ) 
		printf("%s: %d\n", nkey->word, nkey->count);
}

int main( int argc, char * argv[] ) {
	char * prog = argv[0];
	char buf[BUFSIZE];
	struct key * keytab;
	int num_keys, other = 0;
	char * word;

	if (argc < 2) {
		fprintf(stderr, "usage: %s <keyword>+\n", prog );
		exit(1);
	}
	num_keys = argc-1;
	keytab = init_keytab( num_keys, &argv[1] );

# ifndef USE_GETWORD
	/* Problem Pufferueberlauf !! */
	while ( scanf( "%s", buf ) != EOF) 
		if (! find_word( num_keys, keytab, buf ))
			other++;
# else
	/* besser */
	while ( (word = getword()) ) 
		if (! find_word( num_keys, keytab, word ))
			other++;
# endif

	print_keys( num_keys, keytab );
	printf("other: %d\n", other );
}
